/*
 This file is part of Subsonic.

 Subsonic is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 Subsonic is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Subsonic.  If not, see <http://www.gnu.org/licenses/>.

 Copyright 2009 (C) Sindre Mehus
 */
package net.sourceforge.subsonic.androidapp.util;

/**
 * @author Sindre Mehus
 * @version $Id$
 */
public final class Constants {

    // Character encoding used throughout.
    public static final String UTF_8 = "UTF-8";

    // REST protocol version and client ID.
    public static final String REST_PROTOCOL_VERSION = "1.2.0";
    public static final String REST_CLIENT_ID = "android";

    // Names for intent extras.
    public static final String INTENT_EXTRA_NAME_ID = "subsonic.id";
    public static final String INTENT_EXTRA_NAME_NAME = "subsonic.name";
    public static final String INTENT_EXTRA_NAME_AUTOPLAY = "subsonic.playall";
    public static final String INTENT_EXTRA_NAME_ERROR = "subsonic.error";
    public static final String INTENT_EXTRA_NAME_QUERY = "subsonic.query";
    public static final String INTENT_EXTRA_NAME_PLAYLIST_ID = "subsonic.playlist.id";
    public static final String INTENT_EXTRA_NAME_PLAYLIST_NAME = "subsonic.playlist.name";
    public static final String INTENT_EXTRA_NAME_ALBUM_LIST_TYPE = "subsonic.albumlisttype";
    public static final String INTENT_EXTRA_NAME_ALBUM_LIST_SIZE = "subsonic.albumlistsize";
    public static final String INTENT_EXTRA_NAME_ALBUM_LIST_OFFSET = "subsonic.albumlistoffset";
    public static final String INTENT_EXTRA_NAME_SHUFFLE = "subsonic.shuffle";
    public static final String INTENT_EXTRA_NAME_REFRESH = "subsonic.refresh";

    public static final String INTENT_EXTRA_LASTFM_APP_NAME = "app-name";
    public static final String INTENT_EXTRA_LASTFM_APP_PACKAGE = "app-package";
    public static final String INTENT_EXTRA_LASTFM_TRACK = "track";
    public static final String INTENT_EXTRA_LASTFM_ARTIST = "artist";
    public static final String INTENT_EXTRA_LASTFM_ALBUM = "album";
    public static final String INTENT_EXTRA_LASTFM_PLAYER = "player";
    public static final String INTENT_EXTRA_LASTFM_DURATION = "duration";
    public static final String INTENT_EXTRA_LASTFM_STATE = "state";

    // Names for external intents
    public static final String INTENT_SCROBBLE_LASTFM = "com.adam.aslfms.notify.playstatechanged";

    // Last.fm scrobbling values
    public static final String LASTFM_APP_NAME = "Ubuntu One Music";
    public static final String LASTFM_APP_PACKAGE = "net.sourceforge.subsonic.androidapp";
    public static final int LASTFM_STATE_START = 0;
    public static final int LASTFM_STATE_RESUME = 1;
    public static final int LASTFM_STATE_PAUSE = 2;
    public static final int LASTFM_STATE_COMPLETE = 3;

    // Notification IDs.
    public static final int NOTIFICATION_ID_PLAYING = 100;
    public static final int NOTIFICATION_ID_ERROR = 101;

    // Preferences keys.
    public static final String PREFERENCES_KEY_SERVER_INSTANCE = "serverInstanceId";
    public static final String PREFERENCES_KEY_SERVER_NAME = "serverName";
    public static final String PREFERENCES_KEY_SERVER_URL = "serverUrl";
    public static final String PREFERENCES_KEY_USERNAME = "username";
    public static final String PREFERENCES_KEY_PASSWORD = "password";
    public static final String PREFERENCES_KEY_INSTALL_TIME = "installTime";
    public static final String PREFERENCES_KEY_MAX_BITRATE_WIFI = "maxBitrateWifi";
    public static final String PREFERENCES_KEY_MAX_BITRATE_MOBILE = "maxBitrateMobile";
    public static final String PREFERENCES_KEY_CACHE_SIZE = "cacheSize";
    public static final String PREFERENCES_KEY_PRELOAD_COUNT = "preloadCount";
    public static final String PREFERENCES_KEY_LASTFM_SCROBBLING = "lastfmScrobbling";

    // Name of the preferences file.
    public static final String PREFERENCES_FILE_NAME = "net.sourceforge.subsonic.u1m_preferences";

    // Number of free trial days for non-licensed servers.
    public static final int FREE_TRIAL_DAYS = 30;

    // URL for project donations.
    public static final String DONATION_URL = "http://subsonic.org/pages/android-donation.jsp";

    public static final String ALBUM_ART_FILE = "folder.jpeg";

    // Whether this is a debug or release build.
    // NOTE: The value of this field is set automatically during ANT build. See build.xml.
    public static final boolean DEBUG = false;

    // URL used for Ubuntu One authentication.
    public static final String U1M_AUTH_URL = "https://one.ubuntu.com/phones/creds/android?scheme=x-ubuntuone-music";

    private Constants() {
    }
}
